/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package testCollection;

public class Time implements Comparable<Time> {

    private int hour;
    private int minutes;
    private boolean beforeMidday;

    public Time(int hour, int minutes, boolean beforeMidday) {
        if (hour < 0 || hour > 11) {
            throw new IllegalArgumentException("bad hour " + hour);
        }
        if (minutes < 0 || minutes > 59) {
            throw new IllegalArgumentException("bad minutes " + minutes);
        }
        this.hour = hour;
        this.minutes = minutes;
        this.beforeMidday = beforeMidday;
    }

    public int getHour() {
        return hour;
    }

    public int getMinutes() {
        return minutes;
    }

    public boolean beforeMidday() {
        return beforeMidday;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Time) {
            Time time = (Time) obj;
            return time.hour == this.hour 
                    && time.minutes == this.minutes
                    && time.beforeMidday == this.beforeMidday;
        } else {
            return false;
        } 
    }

    @Override
    public int hashCode() {
        //return hour + 31*minutes + new Boolean(beforeMidday).hashCode();
        int boolHashCode=0;
        if (beforeMidday) boolHashCode= 1;
        return hour + 31*minutes + boolHashCode*31*31;
    }

    @Override
    public int compareTo(Time o) {
        // a.compareTo(b): compares a and b,
        // and returns a number n :
        // n < 0 if a < b
        // n= 0 if a = b
        // n > 0 of a > b
        int result= 0;
        if (this.beforeMidday != o.beforeMidday) {
            if (this.beforeMidday)
            {
                result= -1;
            } else {
                result= 1;
            }
        }
       if (result != 0) return result;
       result= this.hour - o.hour;
       if (result != 0) return result;
       result= this.minutes - o.minutes;
       return result;
    }

    @Override
    public String toString() {
        String result= hour+ ":"+ minutes;
        if (beforeMidday)
            result+= "AM";
        else
            result+= "PM";
        return result;
    }
    
    
    
}
